define(['app', 'uicontrols'], function(App, $AppUI){
	return App.view.base.extend({
		model: App.i18n,
		template: 
			'<div class="dwc_thr_header-wrap">' +
				'<h2 class="dwc_set_comp" data-co="set-title" data-i18="Console">' + App.helpers._('Console') + '</h2>' +
			'</div>' +
			'<div data-co="set-list" class="clearfix dwc_set_list">' +
				'<div class="dwc_settings_group">' +
					'<input type="checkbox" class="dwc_settings_group-checkbox" checked>' +
					'<h3 class="dwc_settings_group-title" data-i18="General">' + App.helpers._('General') + '</h3>' +
					'<div class="dwc_settings_group-members">' + 
						'<div class="dwc_settings_row">' +
							'<div class="dwc_settings_cell"><div class="dwc_settings_title">Lang</div><span data-i18="label_Lang">' + App.helpers._('label_Lang') + '</span></div>' +
							'<div class="dwc_settings_cell">' + 
								'<a data-co="property-lang" href="javascript:void(0)" class="dwc_dropdown" data-component="dropdown" data-value="" data-id="" data-list=""></a>' +
							'</div>' +
						'</div>' +
						'<div class="dwc_settings_row">' +
							'<div class="dwc_settings_cell"><div class="dwc_settings_title">MaxCheckFileSize</div><span data-i18="label_MaxCheckFileSize">' + App.helpers._('label_MaxCheckFileSize') + '</span></div>' +
							'<div class="dwc_settings_cell">' + 
								'<span data-co="property-maxcheckfilesize" class="dwc_visual-input" data-mes="' + App.helpers._('No_specified') + '" data-component="visualinput" contenteditable data-postfix="' + App.helpers._('vol_Mb') + '" data-i18-attr="data-postfix:vol_Mb"></span>' +
							'</div>' +
						'</div>' +
					'</div>' +
				'</div>' +
			'</div>',
		initialize: function(){
			App.view.base.prototype.initialize.call(this);

			// Set lang:
			var 	list = App.helpers._('items_Lang'),
					buf = list.split(';'),
					hash = {},
					lang = this.model.get('lang'),
					langId = _.escape(App.helpers._('item_' + lang));

			for(var i = 0; i < buf.length; i += 2){
				hash[buf[i]] = buf[i + 1];
			}

			this.controls.propertyLang.
				attr('data-value', hash[lang]).
				data('value', hash[lang]).
				attr('data-id', lang).
				data('id', lang).
				attr('data-list', list).
				data('list', list);
			// set maxCheckFileSize:
			this.controls.propertyMaxcheckfilesize.text(App.i18n.get('maxCheckFileSize'));
		},
		events: {
			dropdownselected: function(e){
				var 	co = e.target && e.target.dataset && e.target.dataset.co,
						target = e.target;

				if(co == 'property-lang'){
					this.model.set('Lang', target.dataset.id);
					App.i18n.switchLang(target.dataset.id); // Attention switchLang callback supported
				}
			},
			visualinputchange: function(e){
				var 	co = e.target && e.target.dataset && e.target.dataset.co,
						value = e.target.textContent;

				if(co == 'property-maxcheckfilesize'){
					var 	num = value - 0;

					if(!isFinite(num) || !num){
						num = App.i18n.get('maxCheckFileSize');
						e.target.textContent = num;						
					}	

					e.target.classList[num > 0 ? 'remove' : 'add' ]('__minimal');
					e.target.classList[App.i18n.set('maxCheckFileSize', num) ? 'remove' : 'add' ]('__mod');
				}
			},
			'click .dwc_settings_group-title': function(e){
				var 	$checkbox = e.target.previousElementSibling;
				
				$checkbox.checked = !$checkbox.checked;
			},
		}
	})
});
