require.config({
    paths: { // Attention: RequireJs paths not resolve more then one aliases for url. Also you can add switch() at settingsPage
        'jquery':           '/lib/jquery.min',
        'underscore':       '/lib/underscore-min',
        'backbone':         '/lib/backbone-min',

        'uicontrols':       '/js/uicontrols', // Controls
        'voc_en':           '/js/vocabulary.en',
        'voc_ru':           '/js/vocabulary.ru',
        'voc_uk':           '/js/vocabulary.uk',
        'voc_de':           '/js/vocabulary.de',
        'voc_fr':           '/js/vocabulary.fr',
        'voc_jp':           '/js/vocabulary.jp',

        'app':              '/js/app', // helpers, base models, App object
        'index':            '/js/index', // index page/layout
        'mainPage':         '/js/main_page',
        'threatsPage':      '/js/threats_page',
        'settingsPage':     '/js/settings_page',
        'infoPage':         '/js/info_page',

        // in dev:
        'settings_console': '/js/console_conf',
        'settings_mode':    '/js/mode_conf',

        // partials:
        'main.divert.popup.js': '/js/main.divert.popup',
        'divert.popup':     '/js/divert.popup',
        'maild_pass.popup': '/js/maild_pass.popup',
        'repackpass.popup': '/js/repackpass.popup',
    },
});

var     _initSettings,
    _vocModule = 'voc_en',
    _navLanguage = (window.navigator.language || window.navigator.browserLanguage || 'en').toLowerCase().split('-');

try{
    _initSettings = JSON.parse(window.localStorage['settings']);
}catch(e){
    _initSettings = {};
}
_initSettings.lang = _initSettings.lang || _navLanguage[0];
_initSettings.maxCheckFileSize = _initSettings.maxCheckFileSize || 32;
_initSettings.appVersion = '11.0.5-1809141724';

switch(_initSettings.lang){
    case 'ru': _vocModule = 'voc_ru'; break;
    case 'uk': _vocModule = 'voc_uk'; break;
    case 'fr': _vocModule = 'voc_fr'; break;
    case 'de': _vocModule = 'voc_de'; break;
    case 'jp': _vocModule = 'voc_jp'; break;
    default: _vocModule = 'voc_en';
}

require(['index', _vocModule], function(App, voc){
    App.i18n.set(_initSettings, {silent: true});
    App.i18n.set('voc', voc);
    App.init();
    var mainView = new App.view.index({
        el: document.getElementById('wrap'),
    });

    if(!(App.DEBUG = false)){
        window.App = App;
    }
});
